@echo off

:: Start DISKPART to assign the EFI System Partition a drive letter
echo Assigning drive letter to EFI partition using DISKPART
(echo list disk && echo select disk 0 && echo list partition && echo select partition 1 && echo assign letter=S) > diskpart_script.txt

diskpart /s diskpart_script.txt
if %errorlevel% neq 0 (
    echo Failed to assign drive letter to the EFI partition.
    del diskpart_script.txt
    pause
    exit /b
)

del diskpart_script.txt

:: Navigate to the Fonts directory
echo Navigating to the Fonts directory
S:
cd EFI\Microsoft\Boot\Fonts
if not "%cd%"=="S:\EFI\Microsoft\Boot\Fonts" (
    echo Failed to navigate to the Fonts directory. Aborting to prevent accidental deletion.
    pause
    exit /b
)

:: Delete all font files
echo Deleting all font files in S:\EFI\Microsoft\Boot\Fonts
del /Q *.*
if %errorlevel% neq 0 (
    echo An error occurred while deleting the font files.
    pause
    exit /b
)

echo All font files deleted successfully.

:: Unassign the drive letter for the EFI partition
echo Removing drive letter from EFI partition
(echo select disk 0 && echo select partition 1 && echo remove letter=S) | diskpart
if %errorlevel% neq 0 (
    echo Failed to remove drive letter from the EFI partition.
    pause
    exit /b
)

echo Script completed successfully.
pause
